> For the complete documentation index, see [llms.txt](https://docs.coinquoter.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coinquoter.com/smart-contracts/quoter/create-signature.md).

# Create Signature

### buildRFQOrder

#### Parameters

| Field              | Type    | Description                                                                                                                                                                                   |
| ------------------ | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| id                 | Number  | It is a pass-through, integer identifier starting at 1                                                                                                                                        |
| expiresInTimestamp | Number  | It is the timestamp in seconds when the limit order will no longer be available for execution. For example: 1623166270029                                                                     |
| takerAddress       | String  | an address of the maker (wallet address)                                                                                                                                                      |
| takerAssetAddress  | String  | the address of taker's asset                                                                                                                                                                  |
| makerAssetAddress  | String  | the address of maker's asset                                                                                                                                                                  |
| takerAmount        | String  | The number of taker asset tokens that you want to sell (in token units). For example: 5 DAI = 5000000000000000000 units.                                                                      |
| makerAmount        | String  | The number of maker asset tokens that you want to receive (in token units). For example: 5 DAI = 5000000000000000000 units.                                                                   |
| makerAddress       | String? | The address of the maker for whom the limit order is being created. This is an optional parameter, if it is not specified, then the limit order will be available for execution for everyone. |
| feeAmount          | String  | It is a transaction fee amount.                                                                                                                                                               |
| feeTokenAddress    | String  | It is the address of the asset on which the fee is charged.                                                                                                                                   |
| frontendAddress    | String  | It is a referral address.                                                                                                                                                                     |

#### Function

```
 buildRFQOrder({
        id,
        expiresInTimestamp,
        takerAssetAddress,
        makerAssetAddress,
        takerAddress,
        makerAddress = ZERO_ADDRESS,
        takerAmount,
        makerAmount,
        feeAmount,
        feeTokenAddress,
        frontendAddress,
    }: RFQOrderData): RFQOrder
```

#### Example response

```
{
   "info":"30469414559710884007278495962",
   "feeAmount":"1000000000000000000",
   "takerAsset":"0xb63b211f1dB545C04829CA0a3E7D8313711E7eA9",
   "makerAsset":"0xca3e951D17C520B42ED98482b1f8B6478D4531E2",
   "feeTokenAddress":"0x65e3E8A0218F56858DDD669eF2B2e42f928749cD",
   "frontendAddress":"0x98C3CEC32166936672A75FD7D85ad92eb5178D84",
   "takerAssetData":"0x23b872dd000000000000000000000000da0dd31b18c6babc35e7d59f94fae7a180594c7b00000000000000000000000098c3cec32166936672a75fd7d85ad92eb5178d840000000000000000000000000000000000000000000000000000000000989680",
   "makerAssetData":"0x23b872dd00000000000000000000000098c3cec32166936672a75fd7d85ad92eb5178d84000000000000000000000000da0dd31b18c6babc35e7d59f94fae7a180594c7b00000000000000000000000000000000000000000000000578a51c037e9d8260"
}
```

### buildRFQOrderTypedData

#### Parameters

| Field | Type     | Description                                         |
| ----- | -------- | --------------------------------------------------- |
| order | RFQOrder | It is a RFQOrder created with buildRFQOrder method. |

#### Function

```
buildRFQOrderTypedData(order: RFQOrder): EIP712TypedData { }
```

#### Example response

```
{
   "primaryType":"OrderRFQ",
   "types":{
      "EIP712Domain":[
         {
            "name":"name",
            "type":"string"
         },
         {
            "name":"version",
            "type":"string"
         },
         {
            "name":"chainId",
            "type":"uint256"
         },
         {
            "name":"verifyingContract",
            "type":"address"
         }
      ],
      "OrderRFQ":[
         {
            "name":"info",
            "type":"uint256"
         },
         {
            "name":"feeAmount",
            "type":"uint256"
         },
         {
            "name":"takerAsset",
            "type":"address"
         },
         {
            "name":"makerAsset",
            "type":"address"
         },
         {
            "name":"feeTokenAddress",
            "type":"address"
         },
         {
            "name":"frontendAddress",
            "type":"address"
         },
         {
            "name":"takerAssetData",
            "type":"bytes"
         },
         {
            "name":"makerAssetData",
            "type":"bytes"
         }
      ]
   },
   "domain":{
      "name":"1inch Limit Order Protocol",
      "version":"1",
      "chainId":1,
      "verifyingContract":"0x592281754AAe7252ae4A6e730eCe05303C839914"
   },
   "message":{
      "info":"30469414559710884007278495962",
      "feeAmount":"1000000000000000000",
      "takerAsset":"0xb63b211f1dB545C04829CA0a3E7D8313711E7eA9",
      "makerAsset":"0xca3e951D17C520B42ED98482b1f8B6478D4531E2",
      "feeTokenAddress":"0x65e3E8A0218F56858DDD669eF2B2e42f928749cD",
      "frontendAddress":"0x98C3CEC32166936672A75FD7D85ad92eb5178D84",
      "takerAssetData":"0x23b872dd000000000000000000000000da0dd31b18c6babc35e7d59f94fae7a180594c7b00000000000000000000000098c3cec32166936672a75fd7d85ad92eb5178d840000000000000000000000000000000000000000000000000000000000989680",
      "makerAssetData":"0x23b872dd00000000000000000000000098c3cec32166936672a75fd7d85ad92eb5178d84000000000000000000000000da0dd31b18c6babc35e7d59f94fae7a180594c7b00000000000000000000000000000000000000000000000578a51c037e9d8260"
   }
}
```

### buildOrderSignature

#### Parameters

| Field         | Type            | Description                                                  |
| ------------- | --------------- | ------------------------------------------------------------ |
| walletAddress | String          | An address of the taker (wallet address)                     |
| typedData     | EIP712TypedData | It is a RFQOrder created with buildRFQOrderTypedData method. |

#### Function

```
buildOrderSignature(
    walletAddress: string,    
    typedData: EIP712TypedData
): Promise<LimitOrderSignature> { }
```

#### Example response

```
"0xb538830093c54b03f338d28e7e93905071560ca91a97bb4907bb5d29cb4367f7367147978fc3688449271f79d763759835f46b6b536685a7d9de0b6b1666c1d51b"
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.coinquoter.com/smart-contracts/quoter/create-signature.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
